<ng-container
    *ngIf="{
        lecturerExercise: (lecturerExercise$ | async),
        exerciseWithSteps: (exerciseWithSteps$ | async),
        tableData: (tableData$ | async),
        numberParticipants: (numberParticipants$ | async),
        numberParticipantsWhoStarted: (numberParticipantsWhoStarted$ | async),
        numberParticipantsWhoFinished: (numberParticipantsWhoFinished$ | async),
        numberParticipantsWithProblems: (numberParticipantsWithProblems$ | async),
        percentageTotalDone: (percentageTotalDone$ | async)
    } as local"
>
    <div 
        class="exercise-info"
        *ngIf="local.lecturerExercise && local.exerciseWithSteps"
    >
        <ui-header
            [title]="'exercise-info.title'|translate"
            [hasBackButton]="true"
            [actionButtonIcon]="'delete'"
            (backButtonIsClicked)="navigateToHome()"
            (actionButtonIsClicked)="showDeleteModal = true"
        ></ui-header>
        <h2>
            {{'exercise-create-steps.exercise-info' | translate}}
        </h2>        
        <span>{{'exercise-create-steps.exercise' | translate}}: <b>{{local.lecturerExercise.name}}</b> </span>
        <span>{{'exercise-create-steps.course' | translate}}: <b>{{local.lecturerExercise.coursefullname}}</b> </span>
        <span class="last-span">{{'home.submission-until' | translate}} {{local.lecturerExercise.duedate*1000 | date: 'dd.MM.yyyy'}} {{'home.submission-at'|translate}} {{local.lecturerExercise.duedate*1000  | date: 'hh:mm'}} {{'home.submission-clock'|translate}}.</span>
        <span class="no-participants" *ngIf="!local.numberParticipants">{{'exercise-info.no-participants' | translate}}</span>
        <h2 *ngIf="local.numberParticipants">
            {{'exercise-info.stats.title' | translate}}
        </h2>  
        <div class="data-stats-wrapper" *ngIf="local.numberParticipants">
            <ui-data-stats
                *ngIf="(local.numberParticipantsWhoStarted || local.numberParticipantsWhoStarted === 0) && (local.numberParticipants)"
                [value]="local.numberParticipantsWhoStarted + ('exercise-info.stats.of' | translate) + local.numberParticipants"
                [text]="'exercise-info.stats.started' | translate"
                [percentage]="local.numberParticipantsWhoStarted / local.numberParticipants * 100"
            ></ui-data-stats>
            <ui-data-stats
                *ngIf="(local.numberParticipantsWhoFinished || local.numberParticipantsWhoFinished === 0) && (local.numberParticipants)"
                [value]="local.numberParticipantsWhoFinished + ('exercise-info.stats.of' | translate) + local.numberParticipants"
                [text]="'exercise-info.stats.finished' | translate"
                [percentage]="local.numberParticipantsWhoFinished / local.numberParticipants * 100"
            ></ui-data-stats>
            <ui-data-stats
                *ngIf="(local.numberParticipantsWithProblems || local.numberParticipantsWithProblems === 0) && (local.numberParticipants)"
                [value]="local.numberParticipantsWithProblems + ('exercise-info.stats.of' | translate) + local.numberParticipants"
                [text]="'exercise-info.stats.problem' | translate"
                [percentage]="local.numberParticipantsWithProblems / local.numberParticipants * 100"
            ></ui-data-stats>        
            <ui-data-stats
                *ngIf="(local.percentageTotalDone || local.percentageTotalDone === 0)"
                [value]="local.percentageTotalDone + '%'"
                [text]="'exercise-info.stats.total-done' | translate"
                [percentage]="local.percentageTotalDone"
            ></ui-data-stats>         
        </div>
        <h2 *ngIf="local.numberParticipants">
            {{'exercise-info.steps-overview' | translate}}
        </h2>
        <table class="exercise-info-table" *ngIf="local.numberParticipants">
            <thead>
              <tr>
                <th class="th-name">{{'exercise-info.participant'|translate}}</th>
                <ng-container *ngFor="let step of local.exerciseWithSteps.steps; index as i;">
                    <th><span>{{'exercise-create-steps.step'|translate}} {{i+1}}:</span><br/>{{step.name}}</th>
                </ng-container>
              </tr>
            </thead>
            <tbody>
                <ng-container *ngFor="let tableEntry of local.tableData">
                    <tr>
                        <th>{{tableEntry.participant.firstname}} {{tableEntry.participant.lastname}}</th>
                        <ng-container *ngFor="let exerciseStepStatus of tableEntry.exerciseStepStatuses">
                            <td
                                [class.done]="exerciseStepStatus.status === ExerciseStepStatus.DONE"
                                [class.doing]="exerciseStepStatus.status === ExerciseStepStatus.DOING"
                                [class.todo]="exerciseStepStatus.status === ExerciseStepStatus.TODO"
                                [class.problem]="exerciseStepStatus.status === ExerciseStepStatus.PROBLEM"
                            >{{exerciseStepStatus.status}}</td>
                        </ng-container>
                    </tr>
                </ng-container>
            </tbody>
          </table>
          
    </div>

</ng-container>


<ui-dialog
    [title]="'exercise-info.dialog.title' | translate"
    [description]="'exercise-info.dialog.description' | translate"
    [opened]="showDeleteModal"
    [abortButtonText]="'exercise-info.dialog.abort' | translate"
    [confirmButtonText]="'exercise-info.dialog.confirm' | translate"
    (closed)="showDeleteModal = false"
    (confirmed)="deleteExerciseWithSteps()"
></ui-dialog>